<template>
  <a-spin :spinning="confirmLoading">
    <a-form ref="formRef" class="antd-modal-form" :labelCol="labelCol" :wrapperCol="wrapperCol">
      <a-row>
        <a-col :span="24">
          <a-form-item label="数据唯一标识" v-bind="validateInfos.sourceDataKey">
            <a-row>
              <a-col :span="12">
                <a-input v-model:value="formData.sourceDataKey" placeholder="请输入数据唯一标识" :disabled="disabled"></a-input>
              </a-col>
              <a-col :span="12">
                <a-button @click="getSourceDataKey" type="primary">生成数据唯一标识</a-button>
              </a-col>
            </a-row>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="选择项目" v-bind="validateInfos.projectCode">
            <JSelectGcProject v-model:value="formData.projectCode" :disabled="disabled" v-if="transactionTypeNameFlag"></JSelectGcProject>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="药采项目编号" v-bind="validateInfos.tenderProjectCode">
            <a-row>
              <a-col :span="12">
                <a-input v-model:value="formData.tenderProjectCode" placeholder="请输入药采项目编号" :disabled="disabled"></a-input>
              </a-col>
              <a-col :span="12">
                <a-button @click="getTenderProjectCode" type="primary">生成药采项目编号</a-button>
              </a-col>
            </a-row>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="公告类型" v-bind="validateInfos.noticeTypeCodeId">
            <JSelectAnnouncementType v-model:value="formData.noticeTypeCodeId" :disabled="disabled" v-if="transactionTypeNameFlag"></JSelectAnnouncementType>
          </a-form-item>
        </a-col>

        <a-col :span="24">
          <a-form-item label="公告发布时间" v-bind="validateInfos.noticeSendTime">
            <a-date-picker placeholder="请选择公告发布时间"  v-model:value="formData.noticeSendTime" showTime value-format="YYYY-MM-DD HH:mm:ss" style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="公告标题" v-bind="validateInfos.noticeName">
            <a-input v-model:value="formData.noticeName" placeholder="请输入公告标题" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="公告内容" v-bind="validateInfos.noticeContent">
            <j-editor v-model:value="formData.noticeContent" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="附件" v-bind="validateInfos.file">
            <j-upload v-model:value="formData.file"  :disabled="disabled" ></j-upload>
          </a-form-item>
        </a-col>
      </a-row>
    </a-form>
  </a-spin>
</template>

<script lang="ts" setup>
import { ref, reactive, defineExpose, nextTick, defineProps, computed, onMounted } from 'vue';
import { defHttp } from '/@/utils/http/axios';
import { useMessage } from '/@/hooks/web/useMessage';
import JDictSelectTag from '/@/components/Form/src/jeecg/components/JDictSelectTag.vue';
import JUpload from '/@/components/Form/src/jeecg/components/JUpload/JUpload.vue';
import JEditor from '/@/components/Form/src/jeecg/components/JEditor.vue';
import { getValueType } from '/@/utils';
import { saveOrUpdate } from '../GgzyContentDistribution.api';
import { Form } from 'ant-design-vue';
import JSelectGcProject from '/@/components/Form/src/jeecg/components/JSelectGcProject.vue';
import JSelectAnnouncementType from '/@/components/Form/src/jeecg/components/JSelectAnnouncementType.vue';
import JSelectRegionCode from '/@/components/Form/src/jeecg/components/JSelectRegionCode.vue';
import JSelectIndustriesType from '/@/components/Form/src/jeecg/components/JSelectIndustriesType.vue';
import JSelectPlatformCode from '/@/components/Form/src/jeecg/components/JSelectPlatformCode.vue';
const props = defineProps({
  formDisabled: { type: Boolean, default: false },
  formData: { type: Object, default: ()=>{} },
  formBpm: { type: Boolean, default: true }
});
const formRef = ref();
const useForm = Form.useForm;
const emit = defineEmits(['register', 'ok']);
const formData = reactive<Record<string, any>>({
  id: '',
  sourceDataKey: '',
  projectCode: '',
  projectName: '',
  tenderProjectCode: '',
  noticeName: '',
  noticeContent: '',
  noticeSendTime: '',
  noticeNature: '',
  noticeNatureName: '',
  regionCode: '',
  regionName: '',
  industriesTypeCode: '',
  industriesTypeName: '',
  platformCode: '',
  platformName: '',
  noticeTypeCode: '',
  noticeTypeCodeId: '',
  noticeTypeName: '',
  transactionTypeCode: '',
  transactionTypeName: '',
  bulletinTypeCode: '',
  bulletinTypeName: '',
  bulletinDuty: '',
  dataSourceCode: '',
  dataSourceName: '',
  noticeBidNum: '',
  bidSectionCodes: '',
  docGetStartTime: '',
  docGetEndTime: '',
  bidDocReferEndTime: '',
  bidOpenTime: '',
  validPeriod: undefined,
  clarifyTime: '',
  submitTime: '',
  bidOpeningAddress: '',
  bidOpeningTime: '',
  bidFinishTime: '',
  file: '',
  docstatus: '',
  docpubtime: '',
  isSynchronous: '',
});
const { createMessage } = useMessage();
const labelCol = ref<any>({ xs: { span: 24 }, sm: { span: 5 } });
const wrapperCol = ref<any>({ xs: { span: 24 }, sm: { span: 16 } });
const confirmLoading = ref<boolean>(false);
const transactionTypeNameFlag = ref<boolean>(false);
//表单验证
const validatorRules = {
  sourceDataKey: [{ required: true, message: '请输入数据唯一标识!'},],
  projectCode: [{ required: true, message: '请输入项目编号!'},],
  tenderProjectCode: [{ required: true, message: '请输入药采项目编号!'},],
  noticeTypeCodeId: [{ required: true, message: '请输入公告类型!'},],
  noticeSendTime: [{ required: true, message: '请输入公告发布时间!'},],
  noticeName: [{ required: true, message: '请输入公告标题!'},],
  noticeContent: [{ required: true, message: '请输入公告内容!'},],
};
const { resetFields, validate, validateInfos } = useForm(formData, validatorRules, { immediate: true });

// 表单禁用
const disabled = computed(()=>{
  if(props.formBpm === true){
    if(props.formData.disabled === false){
      return false;
    }else{
      return true;
    }
  }
  return props.formDisabled;
});


/**
 * 新增
 */
function add() {
  edit({});
}

/**
 * 编辑
 */
function edit(record) {
  nextTick(() => {
    resetFields();
    //赋值
    Object.assign(formData, record);
  });
}

/**
 * 提交数据
 */
async function submitForm() {
  // 触发表单验证
  await validate();
  confirmLoading.value = true;
  const isUpdate = ref<boolean>(false);
  //时间格式化
  let model = formData;
  if (model.id) {
    isUpdate.value = true;
  }
  //循环数据
  for (let data in model) {
    //如果该数据是数组并且是字符串类型
    if (model[data] instanceof Array) {
      let valueType = getValueType(formRef.value.getProps, data);
      //如果是字符串类型的需要变成以逗号分割的字符串
      if (valueType === 'string') {
        model[data] = model[data].join(',');
      }
    }
  }
  await saveOrUpdate(model, isUpdate.value)
    .then((res) => {
      if (res.success) {
        createMessage.success(res.message);
        emit('ok');
      } else {
        createMessage.warning(res.message);
      }
    })
    .finally(() => {
      confirmLoading.value = false;
    });
}



function getSourceDataKey() {
  defHttp.get({
    url:'/ggzycontentdistribution/ggzyContentDistribution/getSourceDataKey',
    timeout:100000,
  }).then((res)=>{
    formData.sourceDataKey = res;
  })
}

function getTenderProjectCode() {
  defHttp.get({
    url:'/ggzycontentdistribution/ggzyContentDistribution/getProjectCode',
    timeout:100000,
  }).then((res)=>{
    formData.tenderProjectCode = res;
  })
}

onMounted(()=>{
  transactionTypeNameFlag.value = false;
  sessionStorage.setItem("transactionTypeName","");
  sessionStorage.setItem("transactionTypeName","药采交易");
  transactionTypeNameFlag.value = true;
})


defineExpose({
  add,
  edit,
  submitForm,
});
</script>

<style lang="less" scoped>
.antd-modal-form {
  height: 500px !important;
  overflow-y: auto;
  padding: 14px;
}
</style>
